
/*
	General command line functionality.
	TODO: make into a library and require.
*/


commands ∆ {}
help ∆ {}
history ∆ {
	filename: ∅
}

readline ∆≣ 'readline'
jgirl ∆≣ 'jgirl'

➮ dispatch ctx a f {
	args ∆ (a ⌶ ':js:')⁰ ⌶ ' '
	⧖ argsꕉ ≟ '' { args ⬈ }
	js ∆  (a ⌶ ':js:')¹
	c ∆ args ⬉
	⌥ c ≟ ∅ { c = 'news' }
	⌥ c ≟ 'q' { c = 'quit' }
	⌥ c ≟ 'h' { c = 'help' }
	⌥ commandsᶜ ≠ ∅ {
		commandsᶜ(ctx, args, f, js)
	}
	⎇ {
		ロ 'Unknown command "'+c+'".'
		f()
	}
}

➮ exec ctx command_line done {
	dispatch(ctx, command_line.trim(), done)
}

➮ findSimilarCommand {
	K ∆ ⚷ commands
	R ∆ []
	k ► K {
		m ∆ k≀a ≟ 0
		⌥ m {
			R ⬊ k
		}
	}
	$ R
}

commands.quit = ➮ {
	ロ
	ロ 'Good bye.'
	save_history(history.filename)
	⚑
}

➮ startREPL ctx filename {
	rl ∆ readline.createInterface({
		input: process.stdin, output: process.stdout, 
		terminal: ⦿, completer: completer
	})
	rl.setPrompt('^ ')
	promptWrapper()
	
	➮ promptWrapper {
		❰module.exports.post_command❱ module.exports.post_command()
		ロ
		rl.prompt()
	}
	rl.on('line', ➮ {
		save_history(history.filename)
		❰module.exports.pre_command❱ module.exports.pre_command()
		dispatch(ctx, a.trim(), promptWrapper)
		$ ⦾
	})
	.on('close', commands.quit)
	.on('SIGCONT', ➮ { 
		ロ 'Welcome back.\n'
		rl.prompt()
	})
	.on('SIGINT', commands.quit)
	.on('SIGKILL', commands.quit)
	.on('SIGTSTP', ➮ {
		ロ rl
		ロ ' Going to background...'⦙
		process.kill(process.pid, 'SIGSTOP')
		$ ⦾
	})
	
	➮ completer line callback {
		R ∆ []
		R = findSimilarCommand(line)
		callback(null, [R, line]);
	}
	history.filename = filename.replace('~', ≣('os').homedir())
	load_history(rl)
}	

commands.help = ➮ - ctx args f {
	⌥ args↥ ≟ 0 {
		❰!help.basic❱
			ロ 'help.basic is not defined'
		◇
			ロ help.basic
			⁋
	} 
	aa ∆ args ⫴ ' '
	⌥ help[aa] {
		ロ help[aa]
	} ⎇ {
		⌥ aa ≟ '' {
			ロ 'Help topics available:'
			⧗(n in help)
			ロ '   help ' + n
		}
		⎇ {
			ロ 'Unknown help topic "'+aa+'", type "help" to see the list of available topics.'
		}
	}
//	ロ
	f()
}

➮ save_history filename {
	❰history.filename❱
		rl ∆ history.rl
		J ∆ {
			history: rl.history,
			index: rl.historyIndex
		}
		try {
			⛃ (history.filename, ꗌJ)
		} catch(e) { }
		⁋
}

➮ load_history rl {
	❰history.filename❱
		history.rl = rl
		try {
			J ∆ ꖇ (⛁history.filename ≂)
			rl.historyIndex = J.index
			rl.history = J.history
		}
		catch (e) { }
		⁋
}

➮ parse inp required optional f {
	❰inp↥ ≟ 0❱ $ {}
	all ∆ required ꗚ optional
	J ∆ jgirl.from(inp ⫴ ' ', all)
	ok ∆ ⦿
	i ► required {
		❰Jⁱ ≟ ∅❱
			ok = ⦾
			@ ⁋
	}
	❰!ok❱
		//f({ok: ⦾, msg: 'arguments required: ' + required ⫴ ', ' + '.'})
		ロ 'Arguments required: ' + required ⫴ ', ' + '.'
		f()
		$ ⁋
	K ∆ ⚷ J
	unknown ∆ []
	i ► K {
		❰all ≀ i < 0 && i ≠ 'args'❱ unknown ⬊ i
	}
	
	❰unknown↥ > 0❱
		s ∆ ''
		❰unknown↥ > 1❱ s += 's'
		ロ 'Unknown argument'+s+': ' + unknown ⫴ ', ' + '.'
		❰required↥ > 0❱ ロ 'Arguments required: ' + required ⫴ ', ' + '.'
		❰optional↥ > 0❱ ロ 'Arguments optional: ' + optional ⫴ ', ' + '.'
		f()
		$ ⁋
	$ J
}

module.exports.start = startREPL
module.exports.commands = commands
module.exports.help = help
module.exports.history = history
module.exports.parse = parse
module.exports.exec = exec

